## linuxcnc 2.9.4

=== src/Makefile ===
# Some useful targets:
#
#     default (if no make target is specified): Build the software and
#         the docs (if enabled via configure).
#
#     build-software: Build all the realtime and non-realtime software
#         libraries & executables.
#
#     docs: Build all the documentation that's enabled through configure.
#
#
#     install: Install everything (realtime software, non-realtime
#         software, and docs).
#
#     install-software: Install all architecture-specific things (realtime
#         and non-realtime libraries and executables).
#
#     install-docs: Install all enabled documentation into $(DESTDIR).
#

SHELL:=/bin/bash

default: build-software

install: install-software install-docs

install-software: install-kernel-dep install-kernel-indep install-menu

ifeq ($(origin KERNELRELEASE), undefined)
MAKEFLAGS += --warn-undefined-variables
endif

EXTRAFLAGS :=
EXTRA_DEBUG ?=

ifndef DESTDIR
DESTDIR :=
endif

# see http://www.cmcrossroads.com/ask-mr-make/6535-tracing-rule-execution-in-gnu-make
# to trace make execution of make in more detail:
# make VV=1
ifeq ("$(origin VV)", "command line")
    OLD_SHELL := $(SHELL)
    SHELL = $(warning Building $@$(if $<, (from $<))$(if $?, ($? newer)))$(OLD_SHELL)
endif

# Delete the default suffix rules
.SUFFIXES:
.PHONY: default build-software userspace modules clean modclean depclean install install-software install-docs python pythonclean cscope cscopeclean

# A "trivial build" is one which should not include dependency information
# either because it should be usable before dependency information can be
# generated or when it is invalid (clean, docclean) or when running as root
# when the user must guarantee in advance that everything is built
# (setuid, install)
ifeq ($(MAKECMDGOALS),)
TRIVIAL_BUILD=no
else
ifeq ($(filter-out docclean clean setuid install tags swish,$(MAKECMDGOALS)),)
TRIVIAL_BUILD=yes
else
TRIVIAL_BUILD=no
endif
endif

# Used to enable x86 only HAL parts
ifeq ($(shell uname -m),i686)
X86ARCH = true
endif
ifeq ($(shell uname -m),x86_64)
X86ARCH = true
endif

# Beautify output
# ---------------------------------------------------------------------------
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If BUILD_VERBOSE equals 0 then the above command will be hidden.
# If BUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ("$(origin V)", "command line")
  BUILD_VERBOSE = $(V)
endif
ifndef BUILD_VERBOSE
  BUILD_VERBOSE = 0
endif

ifeq ($(BUILD_VERBOSE),1)
  Q =
else
  Q = @
endif

ifeq "$(findstring s,$(filter-out --%, $(MAKEFLAGS)))" ""
ECHO=@echo
VECHO=echo
else
ECHO=@true
VECHO=true
endif

ifeq ($(BASEPWD),)
BASEPWD := $(shell pwd)
export BASEPWD
include Makefile.inc
ifeq ($(origin PYTHONPATH),undefined)
PYTHONPATH:=$(EMC2_HOME)/lib/python
else
PYTHONPATH:=$(EMC2_HOME)/lib/python:$(PYTHONPATH)
endif
export PYTHONPATH
else
include $(BASEPWD)/Makefile.inc
endif
ifeq ($(RTPREFIX),)
$(error Makefile.inc must specify RTPREFIX and other variables)
endif

ifeq ($(TOOL_NML),yes)
  TOOL_NML_FLAG := -DTOOL_NML
  $(info TOOL_NML_FLAG =$(TOOL_NML_FLAG))
else
endif

cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
	     > /dev/null 2>&1; then echo "$(1)"; fi ;)
cxx-option = $(shell if $(CXX) $(CXXFLAGS) $(1) -S -o /dev/null -xc++ /dev/null \
            > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

ifeq ($(origin KERNELRELEASE),undefined)
# When KERNELRELEASE is not defined, this is the userspace build.
# The "modules" target is the gateway to the kernel module build.
build-software: userspace modules
ifeq ($(RUN_IN_PLACE),yes)
ifneq ($(BUILD_SYS),uspace)
	@if [ -f ../bin/linuxcnc_module_helper ]; then if ! [ `id -u` = 0 -a -O ../bin/linuxcnc_module_helper -a -u ../bin/linuxcnc_module_helper ]; then $(VECHO) "You now need to run 'sudo make setuid' in order to run in place."; fi; fi
else
	@if [ -f ../bin/rtapi_app ]; then if ! [ `id -u` = 0 -a -O  ../bin/rtapi_app -a -u ../bin/rtapi_app ]; then $(VECHO) "You now need to run 'sudo make setuid' in order to run in place with access to hardware."; fi; fi
endif
endif

VERSION=$(shell cat ../VERSION)
dist:
	mkdir ../linuxcnc-$(VERSION)
	(cd ../ && git archive master) | (cd ../linuxcnc-$(VERSION) && tar xf -)
	(cd ../linuxcnc-$(VERSION) && ./debian/configure)
	(cd ../linuxcnc-$(VERSION)/src && ./autogen.sh)
	(cd .. && tar zcf linuxcnc-$(VERSION).tar.gz linuxcnc-$(VERSION))
	rm -rf ../linuxcnc-$(VERSION)

# Print 'entering' all the time
MAKEFLAGS += w

# Create the variables with := so that subsequent += alterations keep it
# as a "substitute at assignment time" variable
TARGETS :=
PYTARGETS :=
GENERATED_MANPAGES :=

# Submakefiles from each of these directories will be included if they exist
SUBDIRS := \
    libnml/linklist libnml/cms libnml/rcs libnml/inifile libnml/os_intf \
    libnml/nml libnml/buffer libnml/posemath libnml \
    \
    rtapi/examples/timer rtapi/examples/semaphore rtapi/examples/shmem \
    rtapi/examples/extint rtapi/examples/fifo rtapi/examples rtapi \
    \
    hal/components hal/drivers hal/drivers/mesa-hostmot2 \
    hal/user_comps/devices hal/user_comps/mb2hal \
    hal/user_comps hal/user_comps/vismach hal/user_comps/vfs11_vfd hal/classicladder hal/utils hal \
    hal/user_comps/vfdb_vfd hal/user_comps/wj200_vfd \
    hal/user_comps/pi500_vfd \
    hal/user_comps/huanyang-vfd \
	hal/user_comps/xhc-whb04b-6 \
    \
    emc/usr_intf/axis emc/usr_intf/touchy emc/usr_intf/stepconf emc/usr_intf/pncconf \
    emc/usr_intf/gremlin emc/usr_intf/gscreen emc/usr_intf/pyui emc/usr_intf/qtvcp \
    emc/usr_intf/gmoccapy emc/usr_intf/qtplasmac emc/usr_intf/mdro\
    emc/usr_intf emc/nml_intf emc/task emc/iotask emc/kinematics emc/tp emc/canterp \
    emc/motion emc/ini emc/rs274ngc emc/sai emc/pythonplugin \
    emc/motion-logger \
    emc/tooldata \
    emc \
    \
    module_helper \
    \
    po \
    \
    ../docs/src ../docs/src/source-highlight \
    \
    ../tests \



ULAPISRCS := rtapi/$(RTPREFIX)_ulapi.c

# Each item in INCLUDES is transformed into a -I directive later on
# The top directory is always included
INCLUDES := .

USERSRCS :=
PROGRAMS :=

# When used like $(call TOxxx, ...) these turn a list of source files
# into the corresponding list of object files, dependency files,
# or both.  When a source file has to be compiled with special flags,
# TOOBJSDEPS is used.  Confusingly, TOOBJSDEPS includes preprocessed source
# file names, but this is what allows 'make src.i' to produce proper
# preprocessed source when src.c needs a customized compile flag.
# See Submakefile.skel for an example.
TOOBJS = $(patsubst %.cc,objects/%.o,$(patsubst %.c,objects/%.o,$(1)))
TODEPS = $(patsubst %.cc,objects/%.d,$(patsubst %.c,objects/%.d,$(1)))
TOOBJSDEPS = $(call TOOBJS,$(1)) $(call TODEPS, $(1)) $(patsubst %.cc,%.ii,$(patsubst %.c,%.i,$(1)))

SUBMAKEFILES := $(patsubst %,%/Submakefile,$(SUBDIRS))
-include $(wildcard $(SUBMAKEFILES))

# This checks that all the things listed in USERSRCS are either C files
# or C++ files
ASSERT_EMPTY = $(if $(1), $(error "Should be empty but is not: $(1)"))
$(call ASSERT_EMPTY,$(filter-out %.c %.cc, $(USERSRCS)))

$(call TOOBJS,$(PYSRCS)) : EXTRAFLAGS += -fPIC -fno-strict-aliasing
USERSRCS += $(PYSRCS)

# Find the list of object files for each type of source file
CUSERSRCS := $(filter %.c,$(USERSRCS))
CXXUSERSRCS := $(filter %.cc,$(USERSRCS))
CUSEROBJS := $(call TOOBJS,$(CUSERSRCS))
CXXUSEROBJS += $(call TOOBJS,$(CXXUSERSRCS))

ifeq ($(TRIVIAL_BUILD),no)
# Find the dependency filenames, then include them all
DEPS := $(sort $(patsubst %.o,%.d,$(CUSEROBJS) $(CXXUSEROBJS)))
READ_DEPS = $(wildcard $(DEPS))
$(shell $(VECHO) 1>&2 Reading $(words $(READ_DEPS))/$(words $(DEPS)) dependency files)
-include $(READ_DEPS)
UNREAD_DEPS = $(filter-out $(READ_DEPS), $(DEPS))
$(shell $(VECHO) 1>&2 Done reading dependencies)
endif

# Each directory in $(INCLUDES) is passed as a -I directory when compiling.
INCLUDE := $(patsubst %,-I%, $(INCLUDES)) -I$(RTDIR)/include
INCLUDE += $(PYTHON_CPPFLAGS)
INCLUDE += $(LIBTIRPC_CFLAGS)

# Compilation options.	Perhaps some of these should come from Makefile.inc? (CXXFLAGS now does)
INTEGER_OVERFLOW_FLAGS := -fwrapv
OPT := -Os $(INTEGER_OVERFLOW_FLAGS)
DEBUG := $(DEBUG) -g -Wall -D_FORTIFY_SOURCE=2
CFLAGS := $(INCLUDE) $(OPT) $(DEBUG) $(EXTRA_DEBUG) -DULAPI -std=gnu11 -Werror=implicit-function-declaration $(CFLAGS) $(CPPFLAGS)
CXXFLAGS := $(INCLUDE) $(EXTRA_DEBUG) -DULAPI $(DEBUG) $(OPT) -Werror=overloaded-virtual $(CXXFLAGS) $(CPPFLAGS)
CXXFLAGS += -std=gnu++17
# In Debian 11, any inclusion of <boost/python.hpp> leads to several
# diagnostics from included headers about deprecated features. LinuxCNC does
# not directly use these deprecated features, but it does use boost::python.
# Silence the warnings just when they occur in files using boost/python.hpp by
# adding SILENCE_BOOST_INTERNAL_DIAGNOSTICS_FLAGS to the object's EXTRAFLAGS
SILENCE_BOOST_INTERNAL_DIAGNOSTICS_FLAGS = -DBOOST_ALLOW_DEPRECATED_HEADERS=1 -DBOOST_BIND_GLOBAL_PLACEHOLDERS=1
CFLAGS   += $(TOOL_NML_FLAG)
CXXFLAGS += $(TOOL_NML_FLAG)

ifeq ($(RUN_IN_PLACE),yes)
LDFLAGS := -L$(LIB_DIR) -Wl,-rpath,$(LIB_DIR) $(LIBTIRPC_LIBS) $(LDFLAGS)
else
LDFLAGS := -Wl,-rpath-link,../lib $(LIBTIRPC_LIBS) $(LDFLAGS)
endif

# Rules to make .o (object) files
$(sort $(CUSEROBJS)) : objects/%.o: %.c
	$(ECHO) Compiling $<
	@mkdir -p $(dir $@)
	@rm -f $@
	$(Q)$(CC) -c $(CFLAGS) $(EXTRAFLAGS) \
		-MP -MD -MF "${@:.o=.d}" -MT "$@" \
		$< -o $@

$(sort $(CXXUSEROBJS)) : objects/%.o: %.cc
	$(ECHO) Compiling $<
	@mkdir -p $(dir $@)
	@rm -f $@
	$(Q)$(CXX) -c $(CXXFLAGS) $(EXTRAFLAGS) \
		-MP -MD -MF "${@:.o=.d}" -MT "$@" \
		$< -o $@

# Rules to make .i (preprocessed) files
$(sort $(patsubst %.c,%.i,$(CUSERSRCS))): %.i: %.c
	$(ECHO) Preprocessing $< to $@
	$(Q)$(CC) -dD $(CFLAGS) $(EXTRAFLAGS) -E $< -o $@

$(sort $(patsubst %.cc,%.ii,$(CXXUSERSRCS))): %.ii: %.cc
	$(ECHO) Preprocessing $< to $@
	$(Q)$(CXX) -dD $(CXXFLAGS) $(EXTRAFLAGS) -E $< -o $@

ifeq ($(TRIVIAL_BUILD),no)
configure: configure.ac
	AUTOGEN_TARGET=configure ./autogen.sh

config.h.in: configure.ac
	AUTOGEN_TARGET=config.h.in ./autogen.sh

config.status: configure
	if [ -f config.status ]; then ./config.status --recheck; else \
	    echo 1>&2 "*** linuxcnc is not configured.	Run './configure' with appropriate flags."; \
	    exit 1; \
	fi
endif

Makefile: config.h
config.h: config.h.in config.status
	@./config.status -q --header=$@

INFILES = \
        ../scripts/linuxcnc ../scripts/realtime \
	../scripts/linuxcnc_info ../scripts/setup_designer \
	../scripts/haltcl ../scripts/rtapi.conf Makefile.inc Makefile.modinc \
	../tcl/linuxcnc.tcl ../scripts/halrun ../scripts/rip-environment \
	../scripts/linuxcncmkdesktop \
	../lib/python/nf.py \
	../share/desktop-directories/linuxcnc-doc.directory \
	../share/desktop-directories/linuxcnc-ref.directory \
	../share/desktop-directories/linuxcnc-cnc.directory \
	../share/menus/CNC.menu \
	../share/applications/linuxcnc.desktop \
	../share/applications/linuxcnc-latency.desktop \
	../share/applications/linuxcnc-latency-histogram.desktop \
	../share/applications/linuxcnc-pncconf.desktop \
	../share/applications/linuxcnc-stepconf.desktop \
	../scripts/linuxcnc_var \
	../scripts/halcmd_twopass \
	../scripts/runtests \

$(INFILES): %: %.in config.status
	@./config.status --file=$@

build-software: $(INFILES)

# For each file to be copied to ../include, its location in the source tree
# is listed here.  Note that due to $(INCLUDE), defined above, the include
# files in the source tree are the ones used when building linuxcnc.  The copy
# in ../include is used when building external components of linuxcnc.
SRCHEADERS := \
    emc/linuxcnc.h \
    emc/ini/emcIniFile.hh \
    emc/ini/iniaxis.hh \
    emc/ini/inijoint.hh \
    emc/ini/inispindle.hh \
    emc/ini/initraj.hh \
    emc/ini/inihal.hh \

=== docs/src/remap/Makefile ===
# rebuild svg and eps files from mscgen inputs
# see http://www.mcternan.me.uk/mscgen/

# include in docs like so:
#image::images/iocontrol-prepare.{basebackend-docbook!svg}{basebackend-docbook?eps}[]

MSCGEN=/usr/local/bin/mscgen

%.svg: ../%.msc
	$(MSCGEN) -T svg -i $< -o $@

%.eps: ../%.msc
	$(MSCGEN) -T eps  -i $< -o $@

all:	$(patsubst %.msc,images/%.svg,$(wildcard *.msc)) \
	$(patsubst %.msc,images/%.eps,$(wildcard *.msc))

=== debian/changelog ===
linuxcnc (1:2.9.4-2ubuntu2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Aug 2025 08:19:05 +0200

linuxcnc (1:2.9.4-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2104237).
    Remaining changes:
    - d/patches: Remove upstream definition of _FORTIFY_SOURCE (LP #2104012)

 -- Florent 'Skia' Jacquet <florent.jacquet@canonical.com>  Thu, 19 Jun 2025 11:51:20 +0200

linuxcnc (1:2.9.4-2) unstable; urgency=medium

  * Team upload.

  * Adding build dependency on pyqt5.qtweb{engine,kit} to avoid build
    failures on, as kindly addressed by Adrian <Bunk>. (Closes: #1100882)
  * Re-applied Petter's change to address usrmerge, kindly pointed out
    by Michael <Biebl>. (Closes: #1101346, #1073692)
  * Bumped policy to 4.7.2.
  * Now truly added Andy to Uploaders.

 -- Steffen Moeller <moeller@debian.org>  Mon, 14 Apr 2025 00:10:01 +0200

linuxcnc (1:2.9.4-1ubuntu1) plucky; urgency=medium

  * d/patches: Remove upstream definition of _FORTIFY_SOURCE (LP: #2104012)

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Mon, 24 Mar 2025 19:18:59 +0530

linuxcnc (1:2.9.4-1) unstable; urgency=medium

  * Team upload.

  * New upstream version. (Closes: #1080668)
  * Added Andy to Uploaders.
  * Beautification as instructed by lintian
    - Added debian/format (quilt).
    - Removed overrides for files no longer in archive.

 -- Steffen Moeller <moeller@debian.org>  Sat, 15 Mar 2025 21:05:57 +0100

linuxcnc (1:2.9.4) UNRELEASED; urgency=medium

  * Merge pull request #3283 from Sigma1912/patch-2
  * Gmoccapy: fix bugs caused by GStat missing changes in interpreter mode
  * gmoccapy: expand G-code editor in edit mode
  * gmoccapy: revert "remember position of hbox2 (GtkPaned)"
  * Merge pull request #3269 from hansu/gmoccapy-3-4-9
  * gmoccapy_3_4_9: set version number and update release notes
  * gmoccapy: ensure usage of lowercase for settings in pref file (#3181)
  * gmoccapy: get offset names directly from offsetpage-widget
  * offsetpage-widget: don't translate column 0
  * gmoccapy: revert "added Gtk.Paned for upper main area"
  * gmoccapy: fix wrong states of spindle button images after program abort
  * Follow symlinks in config dir
  * Merge pull request #3259 from BsAtHome/backport-debian_sid-include
  * Necessary include for gettimeofday() in debian:sid.
  * Merge pull request #3251 from Sigma1912/patch-1
  * Add clearer info on ini entries containing lowercase chars
  * Update m-code.adoc - typo exection -> execution
  * Merge pull request #3247 from Sigma1912/patch-1
  * gmoccapy.adoc: correct INI section name [MACROS]
  * Disable "override limits" at the end of the jog. This fixes the issue that the override was not cleared in teleop (homed) mode Issue #2482
  * Doc: User Defined Command, add note on exit codes != 0
  * gmoccapy: update release notes
  * docs: fix list in building-linuxcnc.adoc
  * Typos in carousel.comp
  * Merge pull request #3227 from BsAtHome/backport_2.9_3200-3202
  * Merge pull request #3226 from BsAtHome/backport_2.9_fix-hm2_spi
  * Backport fix hm2_spi driver. This was discovered in master and fixed in PR #3225.
  * Backport fix superfluous NULL check to 2.9 branch (issue #3202).
  * Backport fix invalid printf format to 2.9 branch (issue #3200).
  * Merge pull request #3212 from BsAtHome/hm2_spix-backport-2.9
  * Add missing include to fix checks.
  * Backport the hm2_spix driver for Raspberry Pi 3, 4 and 5 to the 2.9 branch.
  * qtvcp -cam align panel: fix setting x and y scaling
  * gmoccapy: further corrections of sample INI-file regarding really used values
  * docs: update gmoccapy docs regarding INI values
  * halshow: fix error on right click "Set to .."
  * docs: little typo in gstat.adoc
  * gmoccapy: move spaces out of translatable strings
  * Fix "Change to raw strings to fix Python SyntaxWarning" (2)
  * Merge pull request #3179 from hansu/issue-3175
  * Fix "Change to raw strings to fix Python SyntaxWarning"
  * docs: gmoccapy - fix order of settings section according to actual order
  * Merge pull request #3172 from havardAasen/fix-python-syntax-warning
  * Fix deprecated locale.format() -> locale.format_string()
  * Update regex
  * Change to raw strings to fix Python SyntaxWarning
  * docs: improve "HAL Component Generator" doc page (halcompile)
  * Merge pull request #3158 from petterreinholdtsen/bug-debian-1080668-python3-setuptools
  * Dropped use of depricated python3-setuptools / distutils.
  * Merge pull request #3159 from petterreinholdtsen/2.9-upstream-ax-python
  * Fetched latest ax_python.m4 and ax_python_devel.m4 from upstream.
  * Revert "Remove remaining use of deprecated distutils."
  * Revert "Distutils, fix error in previous fix"
  * Distutils, fix error in previous fix Addresses #1080668
  * Remove remaining use of deprecated distutils. Addresses #1080668
  * QTVCP: Typo in error message
  * Merge pull request #3137 from petterreinholdtsen/2.9-avoid-bashism-configure-ac
  * Avoid bashism in configure.ac
  * qtvcp -test_panel: remove distutils library requirement
  * Merge pull request #3048 from hansu/gmoccapy-gcmc-config
  * qtvcp -action_buttons: fix momentary buttons status indicator
  * Merge pull request #3130 from hansu/gmoccapy-deprecation-warning-2
  * gmoccapy: fix deprecation warning "Gtk.StyleContext.get_background_color is deprecated"
  * Merge pull request #3115 from zz912/patch-30
  * Merge pull request #3125 from hansu/gmoccapy-deprecation-warning
  * gscreen: remove deprecated use of GtkLabel constructor
  * gmoccapy: remove deprecated use of GtkLabel constructor
  * Merge pull request #3118 from zz912/patch-31
  * lathe_macros.ini - enable postgui.hal
  * Replace non-exist toolchange.py by stdglue.py
  * Merge pull request #3106 from LinuxCNC/andypugh/gscreen
  * gscreen: Fix Spartan sim homing
  * gscreen: Further tidying up to clear up runtime errors and startup verbosity


=== debian/control ===
Source: linuxcnc
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: LinuxCNC Developers <emc-developers@lists.sourceforge.net>
Uploaders:
    Jeff Epler <jepler@gmail.com>,
    Sebastian Kuzminsky <seb@highlab.com>,
    Andy Pugh <bodgesoc@gmail.com>
Build-Depends:
    debhelper-compat (= 13),
    dh-python,
    libudev-dev,
    docbook-xsl,
    asciidoc,
    ghostscript,
    groff-base,
    imagemagick,
    asciidoc-dblatex,
    autoconf,
    automake,
    bwidget (>= 1.7),
    desktop-file-utils,
    gettext,
    intltool,
    libboost-python-dev,
    libepoxy-dev,
    libgl-dev | libgl1-mesa-dev,
    libglu1-mesa-dev,
    libgtk2.0-dev,
    libgtk-3-dev,
    libmodbus-dev (>= 3.0),
    libgpiod-dev,
    libeditreadline-dev,
    libtirpc-dev,
    libusb-1.0-0-dev,
    libxmu-dev,
    netcat-traditional | netcat-openbsd | netcat,
    po4a,
    procps,
    psmisc,
    python3,
    python3-dev,
    python3-pyqt5.qtwebengine | python3-pyqt5.qtwebkit,
    python3-tk,
    python3-xlib,
    tcl8.6-dev,
    tclx,
    tk8.6-dev,
    xvfb,
    yapps2
Build-Depends-Indep:
    dblatex (>= 0.2.12),
    dvipng,
    fonts-dejavu,
    graphviz,
    groff,
    inkscape,
    python3-lxml,
    source-highlight,
    texlive-extra-utils,
    texlive-font-utils,
    texlive-fonts-recommended,
    texlive-lang-cyrillic,
    texlive-lang-european,
    texlive-lang-french,
    texlive-lang-german,
    texlive-lang-polish,
    texlive-lang-spanish,
    texlive-latex-recommended,
    w3c-linkchecker,
    xsltproc,
    texlive-xetex,
Standards-Version: 4.7.2
Homepage: https://linuxcnc.org/
Vcs-Browser: https://github.com/LinuxCNC/linuxcnc
Vcs-Git: https://github.com/LinuxCNC/linuxcnc.git
Rules-Requires-Root: binary-targets

Package: linuxcnc-uspace-dev
Architecture: any
Conflicts: linuxcnc-sim-dev, linuxcnc-dev
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-serial,
         linuxcnc-uspace (= ${binary:Version}),
         udev,
         python3-yapps
Section: devel
Description: PC based motion controller for real-time Linux
 LinuxCNC is a fully-realised CNC machine controller that can interpret
 machine-control programs (such as G-code), plan trajectories and finally
 output low-level signals to machine control hardware
 .
 LinuxCNC is modular and in principle the HAL (hardware abstraction layer),
 pluggable interpreters and variety of hardware drivers mean that it can
 control almost any software-defined physical system.
 .
 LinuxCNC relies on a realtime kernel to support real-time motion control,
 typically updating the position waypoints every 1mS and reacting to
 input within tens of microseconds.
 .
 Modules exist to use the low-level parts of LinuxCNC as a motion-control
 client for OpenPnP. Interfaces exist for ROS (the Robot Operating System)
 with which LinuxCNC has considerable overlap.
 .
 LinuxCNC supports arbitrary kinematics (the mapping between coordinate
 space and actuator space) and can control both parallel (eg Stewart
 platform) and serial (eg robot arm) systems in addition to conventional
 cartesian machine tools.
 .
 LinuxCNC supports 9 cartesian axes and 16 "Joints" (individual actuators)
 though the joint limit is build-time configurable.
 .
 A variety of interface hardware is supported including Modbus, EtherCAT,
 analogue +/-10V velocity control and Step/Dir. Step/Dir is supported by
 several hardware interfaces, including, but not limited to, the legacy
 Parallel Port.
 .
 A Hardware Abstraction Layer allows for great flexibility in signal
 mapping between the controller and the driver hardware. An extensive
 library of modules allow for complex signal processing within the HAL
 layer. For specialised tasks custom HAL components can be created using
 a C-like syntax and installed with the supplied tools.
 .
 By default LinuxCNC supports RS274 G-code but is extendable to parse
 other grammars such as STEP-NC or Gerber through support for pluggable
 interpreters.
 .
 If you want a computer to control things in the real world
 then LinuxCNC can do it. It is especially applicable to systems that
 are required to follow accurate paths described in cartesian space but
 has been used for numerous other applications.
 .
 This package provides all files that you need to embed parts of LinuxCNC
 in your developments.

Package: linuxcnc-uspace
Conflicts:
    linuxcnc-sim,
    linuxcnc
Breaks:
    linuxcnc-doc-en (<= 2.9.0~pre0+git20220402.2500863908-4),
    linuxcnc-doc-es (<= 2.9.0~pre0+git20220402.2500863908-4),
    linuxcnc-doc-fr (<= 2.9.0~pre0+git20220402.2500863908-4)
Architecture: any
Depends:
    ${misc:Depends},
    ${python3:Depends},
    ${shlibs:Depends},
    libudev-dev,iptables,
    blt,
    mesa-utils,
    python3-tk,
    python3-numpy,
    python3-cairo,
    python3-gi-cairo,
    python3-opengl,
    python3-configobj,
    python3-xlib,
    libgtksourceview-4-dev,
    tcl8.6,
    tk8.6,
    bwidget (>= 1.7),
    tclreadline,
    tclx,
    python3-pyqt5,
    python3-pyqt5.qsci,
    python3-pyqt5.qtsvg,
    python3-pyqt5.qtopengl,
    python3-opencv,
    python3-dbus,
    python3-espeak,
    python3-dbus.mainloop.pyqt5,
    python3-pyqt5.qtwebengine | python3-pyqt5.qtwebkit,
    espeak-ng,
    pyqt5-dev-tools,
    gstreamer1.0-tools,
    espeak,
    sound-theme-freedesktop,
    python3-poppler-qt5,
    procps, psmisc,
    udev
Recommends:
    linuxcnc-doc-en | linuxcnc-doc,
    librsvg2-dev,
    hostmot2-firmware-all, linux-image-rt-amd64 [linux-amd64], linux-image-rt-686-pae [linux-i386],
    python3-pil,
    python3-pil.imagetk
Suggests: mesaflash,
    onboard
Description: motion controller for CNC machines and robots
 LinuxCNC is a fully-realised CNC machine controller that can interpret
 machine-control programs (such as G-code), plan trajectories and finally
 output low-level signals to machine control hardware
 .
 LinuxCNC is modular and in principle the HAL (hardware abstraction layer),
 pluggable interpreters and variety of hardware drivers mean that it can
 control almost any software-defined physical system.
 .
 LinuxCNC relies on a realtime kernel to support real-time motion control,
 typically updating the position waypoints every 1mS and reacting to
 input within tens of microseconds.
 .
 Modules exist to use the low-level parts of LinuxCNC as a motion-control
 client for OpenPnP. Interfaces exist for ROS (the Robot Operating System)
 with which LinuxCNC has considerable overlap.
 .
 LinuxCNC supports arbitrary kinematics (the mapping between coordinate
 space and actuator space) and can control both parallel (eg Stewart
 platform) and serial (eg robot arm) systems in addition to conventional
 cartesian machine tools.
 .
 LinuxCNC supports 9 cartesian axes and 16 "Joints" (individual actuators)
 though the joint limit is build-time configurable.
 .
 A variety of interface hardware is supported including Modbus, EtherCAT,
 analogue +/-10V velocity control and Step/Dir. Step/Dir is supported by
 several hardware interfaces, including, but not limited to, the legacy
 Parallel Port.
 .
 A Hardware Abstraction Layer allows for great flexibility in signal
 mapping between the controller and the driver hardware. An extensive
 library of modules allow for complex signal processing within the HAL
 layer. For specialised tasks custom HAL components can be created using
 a C-like syntax and installed with the supplied tools.
 .
 By default LinuxCNC supports RS274 G-code but is extendable to parse
 other grammars such as STEP-NC or Gerber through support for pluggable
 interpreters.
 .
 If you want a computer to control things in the real world
 then LinuxCNC can do it. It is especially applicable to systems that
 are required to follow accurate paths described in cartesian space but
 has been used for numerous other applications.
 .
 This package provides the main package for LinuxCNC.

Package: linuxcnc-doc-de
Provides: linuxcnc-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xdg-utils
Suggests: pdf-viewer
Description: motion controller for CNC machines and robots (German documentation)
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in German.

Package: linuxcnc-doc-en
Provides: linuxcnc-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: linuxcnc-uspace (<= 2.9.0~pre0+git20220402.2500863908-4),
Replaces: linuxcnc-uspace (<= 2.9.0~pre0+git20220402.2500863908-4)
Recommends: xdg-utils
Suggests: pdf-viewer
Description: motion controller for CNC machines and robots (English documentation)
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in English.

Package: linuxcnc-doc-fr
Provides: linuxcnc-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: linuxcnc-uspace (<= 2.9.0~pre0+git20220402.2500863908-4)
Replaces: linuxcnc-uspace (<= 2.9.0~pre0+git20220402.2500863908-4)
Recommends: xdg-utils
Suggests: pdf-viewer
Description: motion controller for CNC machines and robots (French documentation)
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in French.

Package: linuxcnc-doc-es
Provides: linuxcnc-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: linuxcnc-uspace (<= 2.9.0~pre0+git20220402.2500863908-4)
Replaces: linuxcnc-uspace (<= 2.9.0~pre0+git20220402.2500863908-4)
Recommends: xdg-utils
Suggests: pdf-viewer
Description: motion controller for CNC machines and robots (Spanish documentation)
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in Spanish.

Package: linuxcnc-doc-zh-cn
Provides: linuxcnc-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xdg-utils
Suggests: pdf-viewer
Conflicts: linuxcnc-doc-cn
Replaces: linuxcnc-doc-cn
Description: motion controller for CNC machines and robots (Chinese
 documentation)
 LinuxCNC is the next-generation Enhanced Machine Controller which
 provides motion control for CNC machine tools and robotic
 applications (milling, cutting, routing, etc.).
 .
 This package contains the documentation in Chinese.

=== debian/tests/control ===
Tests: linuxcnc-test
Depends: linuxcnc-uspace
Restrictions: allow-stderr

Tests: rs274-test
Depends: linuxcnc-uspace
Restrictions: flaky

## linuxcnc 2.9.7

=== src/Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 install-software: install-kernel-dep install-kernel-indep install-menu
 
 ifeq ($(origin KERNELRELEASE), undefined)
-MAKEFLAGS += --warn-undefined-variables
+#MAKEFLAGS += --warn-undefined-variables
 endif
 
 EXTRAFLAGS :=

=== debian/changelog ===
linuxcnc (1:2.9.7-1) unstable; urgency=low

  * [ci] publish releases with artifacts - GitHub now builds release debs
  * Revert 7d9ee66  to address #3583 - halui functions stop working in 2.9.5/6
  * Merge pull request #3512 from Sigma1912/patch-1
  * Gmoccapy: Fix arrow key up/down bug in tooleditor

 -- andypugh <andy@bodgesoc.org>  Wed, 22 Oct 2025 23:43:13 +0100

linuxcnc (1:2.9.6) UNRELEASED; urgency=medium

  * qtvcp -Qt5_graphics: issue 2753; preview wrongly uses INI startup code
  * Merge pull request #3567 from Sigma1912/2_9-Correct_bad_fix_for_2753
  * Gremlin: Don't use  RS274NGC_STARTUP_CODE when updating the preview
  * Docs: Address G52 Circular Link #3565

 -- andypugh <andy@bodgesoc.org>  Mon, 22 Sep 2025 22:55:20 +0100

linuxcnc (1:2.9.5) UNRELEASED; urgency=medium

  * tests: save.1 test removed. It's been skipped for 19 years.
  * Merge pull request #3529 from LinuxCNC/andypugh/tests/spindle_limits
  * Merge pull request #3553 from Sigma1912/patch-2
  * Merge pull request #3552 from Sigma1912/halui_fix_axis_and_mdi_command_pins
  * halui: on startup, set the first configured axis as 'is-selected' instead of X
  * halui: Don't create 'halui.axis.'- pins for unconfigured axes
  * qtvcp versa probe: remember setting of auto skew/zero buttons we reopened
  * PyVCP test: result file formatting fixes (#3551)
  * Merge pull request #3537 from DauntlessAq/probe_error_decel_no_inhibit_2.9
  * stepconf -fix human input names in wrong order
  * Tests: Add a test for PyVCP - Specifically Issue #3538
  * Merge pull request #3540 from andronick83/patch-1
  * Added missing period to description of G95. (PR #3542)
  * Deprecate gantry.comp
  * Fix #3538 - "halparam" tag not working in PyVCP
  * probe_error_decel_no_inhibit rebased for 2.9
  * Delete tests/spindle_limits/test.ini
  * tests: Add a test for spindle INI speed limits function
  * Fix a race; add a test to ensure the 'result' and 'stderr' files are closed before continuing to run 'checkresult'.
  * Fix command-line directories acceptance by correct expansion.
  * Fix a race between setting the signal handlers and marking hal_ready().
  * The quit_flag is volatile because it is changed in a signal and used in threads.
  * remove buster from CI
  * debian:  reduce Lintian Warnings. (hardening-no-relro: panelui, module_helper)
  * Fixed word typo in remap.adoc (numberer->numbered).
  * docs: Add back German translation link in stable branch index page.
  * Merge pull request #3493 from BsAtHome/backport_2.9_fix-hm2_modbus
  * Backport hm2_modbus fixes and additions from master.
  * Merge pull request #3479 from Sigma1912/patch-1
  * Update g-code.adoc
  * Gladevcp: Update the .ui and .glade files in the sample configs to Gtk+3.0
  * clarify documentation on stat 'gcodes' and (spindle)'speed' attributes
  * Merge pull request #3460 from Sigma1912/2.9-Fix-preview-update-not-respecting-active-wcs
  * Don't use  RS274NGC_STARTUP_CODE when updating the preview
  * Merge pull request #3454 from Sigma1912/2.9_Fix_issue_3447
  * Gmoccapy: Fix very large numbers for spindle speed and 'Vc' in the gui when using G96
  * Gmoccapy: Fix 'spindle.0.speed-out' pins being reset to wrong value when using G96
  * Merge pull request #3446 from BsAtHome/backport_2.9_hm2_modbus
  * Python 3.7 (Debian 10) has no dictionary merge operator, use alternative syntax.
  * Split declaration/assignment with label because it is not accepted by the compiler in Debian 10 and 11.
  * Backport new hm2_modbus driver to 2.9 branch.
  * Merge pull request #3425 from BsAtHome/backport_2.9_fix-deprecated
  * Merge pull request #3388 from smoe/patch-18
  * Merge pull request #3445 from BsAtHome/backport_2.9_fix-python-313
  * Make 2.9 branch compile with python 3.13
  * Merge pull request #3422 from BsAtHome/backport_2.9_fix_re-syntax-warning
  * Merge pull request #3429 from smoe/typos_29
  * 2.9: typos, punctuation in comments
  * Make using PyConfig conditional on python version >= 3.8.
  * Merge pull request #3423 from BsAtHome/backport_2.9_fix_debug-O0
  * Merge pull request #3424 from BsAtHome/backport_2.9_fix-comment-in-comment
  * Merge pull request #3421 from BsAtHome/backport_2.9_fix_link-version-script
  * Fix deprecated Py_SetProgramName() and deprecated use of Py_UnbufferedStdioFlag.
  * Fix comment in comment
  * Remove forced -O0 optimization flag.
  * Fix invalid escape sequence warnings from halcompile and hal components.
  * Use objdump and awk to extract the rtapi exported symbols
  * Merge pull request #3416 from BsAtHome/fix_2.9_ci-update
  * Fix missing parity error definition
  * Update CI base for 2.9 branch to Ubuntu 24.04.
  * Backport fix of modcompile
  * Merge pull request #3412 from BsAtHome/backport_2.9_fix_update-pktuart-v3
  * Merge pull request #3411 from BsAtHome/backport_fix_make-noise
  * Merge pull request #3410 from BsAtHome/backport_2.9_fix-pointer-compare
  * Varargs export of function is not available in 2.9.
  * Update dependencies with PktUART update. Fix crash bugs and warnings in modbus template.
  * Update, fix and reorganize hostmot2 PktUART to support V3.
  * Remove make terminal clutter
  * Use pointer null compare instead of integer compare.
  * Merge pull request #3407 from BsAtHome/backport-fix_hm2-constify
  * Merge pull request #3405 from BsAtHome/backport-fix_test-halcompile
  * Use const char pointers. Add missing pktuart calls. Prevent hal name overruns.
  * Add stdio.h header for readline versions that need it.
  * debian: updating debian-uploads' changelogs
  * debian: Addressing usrmerge
  * debian: Added Andy as uploader
  * debian: Updated policy standard to 4.7.2
  * orient: Commit 79c0966 had an un-noticed effect on the behaviour of M19 reported in issue #3389
  * Merge pull request #3392 from Sigma1912/2.9-ServoToGo_remove-web-link-to-spamsite
  * ServoToGo: remove old weblinks that now redirect to a spam site
  * halui -fix spindle override using direct value.


=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: linuxcnc
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LinuxCNC Developers <emc-developers@lists.sourceforge.net>
+Maintainer: LinuxCNC Developers <emc-developers@lists.sourceforge.net>
 Uploaders:
     Jeff Epler <jepler@gmail.com>,
     Sebastian Kuzminsky <seb@highlab.com>,
-    Andy Pugh <bodgesoc@gmail.com>
+    Andy Pugh <andy@bodgesoc.org>
 Build-Depends:
     debhelper-compat (= 13),
     dh-python,
@@ -41,8 +40,8 @@
     psmisc,
     python3,
     python3-dev,
+    python3-tk,
     python3-pyqt5.qtwebengine | python3-pyqt5.qtwebkit,
-    python3-tk,
     python3-xlib,
     tcl8.6-dev,
     tclx,

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (C) 2006 Jeff Epler
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# When used to produce a debian package, this file is a script "used to
# control compilation and installation of the executable"

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# Support more robust code and makes code modifications more difficult
# Compare https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Trigger other tools to use the timestamp from debian/changelog
# Compare https://reproducible-builds.org/docs/source-date-epoch/
export SOURCE_DATE_EPOCH ?= $(shell dpkg-parsechangelog -STimestamp)

# Set time & date to the most recent release, for repeatable builds.
TIMESTAMP=$(shell dpkg-parsechangelog -S timestamp)
export DATE=$(shell LANG=C date --date='@$(TIMESTAMP)' '+%d\ %b\ %Y')
export TIME=$(shell LANG=C date --date='@$(TIMESTAMP)' '+%T')

kernel_version = uspace
configure_realtime_arg = --with-realtime=uspace
enable_build_documentation = --enable-build-documentation=pdf
SRCDIR = $(CURDIR)/src
DESTDIR=$(CURDIR)/debian/tmp
DEV_PACKAGE_NAME=linuxcnc-uspace-dev

export PYTHON=/usr/bin/python3

%:
	dh $@ -D$(SRCDIR)

override_dh_auto_configure:
	cd src && ./autogen.sh
	cd src && ./configure \
	    --prefix=/usr --sysconfdir=/etc \
	    --mandir=/usr/share/man \
	    $(configure_realtime_arg) \
	    $(enable_build_documentation) \
	    --disable-check-runtime-deps

override_dh_auto_build-arch:
	dh_auto_build -- build-software

override_dh_auto_build-indep:
ifneq "$(enable_build_documentation)" ""
	dh_auto_build -- manpages
	dh_auto_build -- translateddocs
	dh_auto_build -- docs
endif

override_dh_auto_clean:
	if [ -r src/Makefile.inc -a -r src/config.status ]; then \
	dh_auto_clean; \
	py3clean .; \
	fi

override_dh_auto_install-arch:
	# Install all architecture-dependent libraries and executables
	# in DESTDIR (the staging dir for the main package).
	DESTDIR=$(DESTDIR) $(MAKE) -C src install-software
	py3clean .

	desktop-file-validate $(shell find debian/extras/ share/applications/ -name *.desktop);

	# some clean-up
	rm -f $(DESTDIR)/usr/share/doc/linuxcnc-uspace/examples/sample-configs/*/*position*.txt

override_dh_installdocs-arch:
	# Sample configs go in `usr/share/doc/linuxcnc` (not `.../doc/linuxcnc-uspace`)
	# because that's where the `linuxcnc` launcher script looks for them,
	# and that's inconvenient to change.
	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-uspace
	mkdir -p debian/linuxcnc-uspace/usr/share/doc/linuxcnc
	mv debian/linuxcnc-uspace/usr/share/doc/linuxcnc-uspace/examples debian/linuxcnc-uspace/usr/share/doc/linuxcnc

	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-uspace-dev


override_dh_auto_install-indep:
	DESTDIR=$(DESTDIR) $(MAKE) -C src install-docs install-doc
	# Remove the docs we just built that we don't have debs for yet...
	rm -f $(DESTDIR)/usr/share/doc/linuxcnc/*_nb.pdf

override_dh_installdocs-indep:
	# The G-code quick reference html docs are built as `docs/html/${LANG}/gcode.html`.
	# We install them into `/usr/share/doc/linuxcnc-uspace/` in each
	# linuxcnc-doc-${LANG} package, then rename them there (except
	# for the English one) to include the language in the filename,
	# so they don't collide when we install all the doc debs.
	#
	# Rename the "main" doc directories from
	# `usr/share/doc/linuxcnc-uspace` to `usr/share/doc/linuxcnc`,
	# because that's where the `.desktop` files look for the docs.
	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-doc-de
	mv debian/linuxcnc-doc-de/usr/share/doc/linuxcnc-uspace/gcode.html debian/linuxcnc-doc-de/usr/share/doc/linuxcnc-uspace/gcode_de.html
	mv debian/linuxcnc-doc-de/usr/share/doc/linuxcnc-uspace debian/linuxcnc-doc-de/usr/share/doc/linuxcnc

	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-doc-en
	mv debian/linuxcnc-doc-en/usr/share/doc/linuxcnc-uspace debian/linuxcnc-doc-en/usr/share/doc/linuxcnc

	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-doc-es
	mv debian/linuxcnc-doc-es/usr/share/doc/linuxcnc-uspace/gcode.html debian/linuxcnc-doc-es/usr/share/doc/linuxcnc-uspace/gcode_es.html
	mv debian/linuxcnc-doc-es/usr/share/doc/linuxcnc-uspace debian/linuxcnc-doc-es/usr/share/doc/linuxcnc

	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-doc-fr
	mv debian/linuxcnc-doc-fr/usr/share/doc/linuxcnc-uspace/gcode.html debian/linuxcnc-doc-fr/usr/share/doc/linuxcnc-uspace/gcode_fr.html
	mv debian/linuxcnc-doc-fr/usr/share/doc/linuxcnc-uspace debian/linuxcnc-doc-fr/usr/share/doc/linuxcnc

	dh_installdocs --doc-main-package=linuxcnc-uspace --package=linuxcnc-doc-zh-cn
	mv debian/linuxcnc-doc-zh-cn/usr/share/doc/linuxcnc-uspace/gcode.html debian/linuxcnc-doc-zh-cn/usr/share/doc/linuxcnc-uspace/gcode_zh_CN.html
	mv debian/linuxcnc-doc-zh-cn/usr/share/doc/linuxcnc-uspace debian/linuxcnc-doc-zh-cn/usr/share/doc/linuxcnc


override_dh_compress:
	dh_compress -X.pdf -X.txt -X.hal -X.ini -X.clp -X.var -X.nml -X.tbl -X.xml -Xsample-configs

override_dh_fixperms:
	dh_fixperms -X/linuxcnc_module_helper -X/rtapi_app
	# FIXME: Who sets those -x flags? This better be fixed at the root of the problem - to be found.
	find debian -name linuxcnc.tcl -o -name cbutton.tcl -o -name mdi_text.py -o -name util.py | xargs -r chmod -x
	# override_dh_python3: # not executed, so we attach it to fixperms
	DEB_HOST_ARCH=`dpkg-architecture -qDEB_HOST_ARCH` dh_python3

override_dh_shlibdeps:
	cat debian/linuxcnc-uspace/DEBIAN/shlibs debian/shlibs.pre > debian/shlibs.local
	dh_shlibdeps -u--warnings=0 -l debian/linuxcnc-uspace/usr/lib

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%linuxcnc-$1.tar.gz%" \
   https://github.com/LinuxCNC/linuxcnc/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
